/*
Copyright Renaud GICQUEL 2006-2009  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import rg.corps.*;
import java.util.*; 
import javax.swing.*;

/**
 * classe de condensation sur batterie froide
 * 
 * @author Renaud GICQUEL
 */
public class ColdBattery extends ExtDivider
{
	private static java.util.ResourceBundle resInt_fr = java.util.ResourceBundle.getBundle("IntTh",Locale.getDefault());  
    
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField condenserLoad_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField sigma_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField Q_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField Compr_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField Tout_value = new javax.swing.JTextField();
    
    double Tamont, Taval, Pamont, Paval,P, Xinlet, Tinlet, Hinlet, wetGasFlow;
    String wetGasProcess,H2OProcess,dryGasProcess,dryGasSubstanceName,H2OSubstanceName;
    String wetGasPoint,H2OPoint,dryGasPoint;
    rg.corps.Corps dryGasSubstance;
    rg.corps.Corps H2OSubstance;
    
    double[]inletWetGasFractmol;
    String[]inletWetGasComp;
    Vector inputWetGasComp, dryGasComp;
    double fractH2O,Htot,wetGasM,inlet_w,outlet_w,Qprime_inlet;
    
    String outletMethanolAbsorName="";
    
    double sigma,tau;
    
    public ColdBattery (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JLabel1.setText("effectiveness");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,164,20);
		JPanel1.add(sigma_value);
		sigma_value.setBounds(164,0,100,20);
		sigma_value.setText("0.5");
		JLabel2.setText("condenser load");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,96,164,20);
		JPanel1.add(condenserLoad_value);
		condenserLoad_value.setBounds(164,96,100,20);
		condenserLoad_value.setText("0.5");
		condenserLoad_value.setEditable(false);
		JLabel3.setText("boiler heat");
	//	JPanel1.add(JLabel3);
		JLabel3.setBounds(0,48,164,20);
	//	JPanel1.add(Q_value);
		Q_value.setBounds(164,48,100,20);
		Q_value.setText("0");
		JLabel4.setText("compression power");
	//	JPanel1.add(JLabel4);
		JLabel4.setBounds(0,72,164,20);
	//	JPanel1.add(Compr_value);
		Compr_value.setBounds(164,72,100,20);
		Compr_value.setText("0");
		JLabel5.setText("H2O temperature (C)");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,24,164,20);
		JPanel1.add(Tout_value);
		Tout_value.setBounds(164,24,100,20);
		Tout_value.setText("0");
		type=getType();
		thermoCouplerTypes=new String[1];
 		thermoCouplerTypes[0]="cooler";
    }
    public void init(){
	    getDividerStructure();
        checkConsistency();
    }
    
    public String getType(){
        return "cold battery";
    }
    
	public String getClassDescription(){
	    return "cold battery\none thermocoupler\n\nauthor : R. Gicquel  april 2006\n\nRef : CoolingCoils.doc";
	}

    private double getSigma(){
        
        return Util.lit_d(sigma_value.getText());//lecture  l'cran de la valeur de sigma
        
    }
	public void calculateProcess(){
	
	    getDividerStructure();
        checkConsistency();
	    
	    if(isBuilt){//si le noeud externe est bien configur
	    
            sigma=getSigma();//mthode de calcul de sigma / sigma calculation method
            double TH2O=Util.lit_d(Tout_value.getText())+273.15;

	        dryGasComp=inputWetGasComp;

            //recalcul des fractions molaires pour tenir compte de l'extraction de H2O
            //recalculation of molar fractions to take into account H2O extraction 
	        for(int i=0;i<inletWetGasFractmol.length;i++){//fractions molaire de sortie / outlet molar fractions
	            double x_out=inletWetGasFractmol[i]/(1-sigma*fractH2O);
	            Util.updateMolarComp(dryGasComp,inletWetGasComp[i], x_out);
	        }
            double xH2O_out=(1-sigma)*fractH2O/(1-sigma*fractH2O);//fraction molaire de sortie en H2O /H2O outlet molar fraction
	        Util.updateMolarComp(dryGasComp,"H2O", xH2O_out);
	        
            dryGasSubstance.updateGasComposition(dryGasComp);

            double wetSynGasMolFlow=wetGasFlow/wetGasM;
            double H2OMassFlowTotal=wetSynGasMolFlow*fractH2O*18.01528;
            double H2Oflow=H2OMassFlowTotal*sigma;
            
	        dryGasSubstance.CalcPropCorps(273.15,1, 1); //calcul de l'tat de rfrence / reference state calculation
            getSubstProperties(dryGasSubstanceName);
            double h0subst=Hsubst;
            
            dryGasSubstance.CalcPropCorps(TH2O,20, 0);
            getSubstProperties(dryGasSubstanceName);
            
            outlet_w=xH2O_out*18.01528/M_secpoint/(1-xH2O_out);//(M_H2O)(x_H2O)/(M_gs)/(x_gs)
            double L0_eau=2501.593;  
 
            //Enthalpie du gaz humide en sortie / moist gas outlet enthalpy
            double Qprime_outlet=((Hsubst-h0subst)+outlet_w*L0_eau/(1+outlet_w))*(wetGasFlow-H2Oflow);

            Object obj=Corps.createSubstance(resInt_fr.getString("eau"));//instanciation du corps, encapsul dans un Object
            															//substance instanciation, wrapped in an Object
            Corps lH2O=(Corps)obj;//transtyping the Object
            lH2O.CalcPropCorps(TH2O,20, 0);
            getSubstProperties(resInt_fr.getString("eau"));
            
            //Enthalpie de l'eau en sortie / water outlet enthalpy
            double Heau=Hsubst*H2Oflow;
            
            //charge du condenseur / condenser load
            double condLoad=Qprime_inlet-Heau-Qprime_outlet;
            
            //affichages  l'cran / screen display
            Compr_value.setText(Util.aff_d(0,2));
            Q_value.setText(Util.aff_d(0,2));
            condenserLoad_value.setText(Util.aff_d(condLoad,2));
            sigma_value.setText(Util.aff_d(sigma,2));

            //mise  jour du thermocoupleur, comme pinchFluid, DTmin=10
            //thermocoupler update, as pinchFluid, DTmin=10
	        updateThermoCoupler("cooler", Tinlet, TH2O, condLoad, wetGasFlow,true,10);
	   
	        //mise  jour du noeud en utilisant les mthodes gnriques
	        //node update using generic methods
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
	        setupVector(H2OProcess, H2OPoint, 0, H2Oflow, TH2O, Pamont, 1);
	        setupVector(dryGasProcess, dryGasPoint, 1, wetGasFlow-H2Oflow, TH2O, Pamont, 0);
	        setupVector(wetGasProcess, wetGasPoint, 2, wetGasFlow, Tinlet, Pamont, Xinlet);
            updateDivider(vTransfo,vPoints,Tinlet,Qprime_inlet);

	        de.updateProcess(setEnergyTypes(wetGasProcess,0,0,0));
        }

	}
	
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        H2OProcess="";
        dryGasProcess="";
        if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 2";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String amont=(String)vBranch[j].elementAt(1);//gets the upstream point name
	            getPointProperties(amont);//direct parsing of point property vector
                getSubstProperties(nomCorps);
                String nom=nomCorps;
                if(typeSubst==1){//le corps de sortie est de l'eau
	                H2OProcess=nomBranche[j];
	                H2OPoint=amont;
	            }
	            else if(typeSubst==4){//le corps de sortie est un gaz compos
	                dryGasProcess=nomBranche[j];
	                dryGasPoint=amont;
                    args=new String[2];
                    args[0]="process";//type of the element (see method getProperties(String[] args))
                    args[1]=dryGasProcess;//name of the process (see method getProperties(String[] args))
                    Vector vProp=proj.getProperties(args);
                    amont=(String)vProp.elementAt(1);//gets the upstream point name
                    getPointProperties(amont);//direct parsing of point property vector
	                dryGasSubstance=lecorps;
	                dryGasSubstanceName=nomCorps;
	            }
	            else{//le corps de sortie n'est ni de l'eau ni un gaz compos
	                String msg = "Error: the outlet substance is not of the right type";
	                JOptionPane.showMessageDialog(de, msg);  
	            }
	        }
	        if((H2OProcess.equals(""))||(dryGasProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(de, msg);  
	            isBuilt=false;
	        }
        }
        wetGasProcess=mainProcess;
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=wetGasProcess;//name of the process (see method getProperties(String[] args))
	    Vector vPropMain=proj.getProperties(args);
	    Double f=(Double)vPropMain.elementAt(3);
	    wetGasFlow=f.doubleValue();
	    String aval=(String)vPropMain.elementAt(2);//gets the downstream point name
	    getPointProperties(aval);//direct parsing of point property vector
        Vector vComp=lecorps.getGasComposition();
	    wetGasPoint=aval;
	    Tinlet=Tpoint;
	    Hinlet=Hpoint;
        Pamont=Ppoint;
        
	    lecorps.CalcPropCorps(273.15,Ppoint, 1); //calcul de l'tat de rfrence
        getSubstProperties(nomCorps);
        double h0subst=Hsubst;
        
	    lecorps.CalcPropCorps(Tpoint,Ppoint, 1); //recalcul de l'tat de sortie (fournit Hsubst)
        getSubstProperties(nomCorps);
        inputWetGasComp=lecorps.getGasComposition();//composition du gaz  traiter
        fractH2O=Util.molarComp(inputWetGasComp,"H2O");//fraction molaire de H2O
        
        //on calcule w inlet par la formule de dfinition, pour viter, compte tenu de la
        //temprature leve du gaz, d'avoir  estimer les conditions de saturation
        //cf. p. 71-72 tome 1
        inlet_w=fractH2O*18.01528/M_secpoint/(1-fractH2O);//(M_H2O)(x_H2O)/(M_gs)/(x_gs)
        double L0_eau=2501.593;  
        
        //Enthalpie totale d'entre
        Qprime_inlet=((Hinlet-h0subst)+inlet_w*L0_eau/(1+inlet_w))*wetGasFlow;
        
        wetGasM=Msubst;//masse molaire du gaz  traiter

        //chargement du tableau des fractions molaires du gaz  traiter
        Integer i=(Integer)inputWetGasComp.elementAt(0);
	    int nComp=i.intValue(); 
        inletWetGasComp= new String[nComp];
        Double[]fracMol= new Double[nComp];
        inletWetGasFractmol= new double[nComp];
	    inletWetGasComp=(String[])inputWetGasComp.elementAt(1);
	    fracMol=(Double[])inputWetGasComp.elementAt(2);
        for(int j=0;j<nComp;j++){
            inletWetGasFractmol[j]= fracMol[j].doubleValue();
        }
        
	    
	    

        //Check the substance at inlet
	    if(!((typeSubst==4)&&(Util.contains(vComp,"H2O")))){
	        String msg = "Error on main process substance,which is not a gas containing H2O";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
	    }
        
    }

	public void readCompParameters(String ligne_data){
        String valeur=Util.extr_value(ligne_data, "condenserLoad_value");
        double condenserLoad=0;
        if(valeur!=null)condenserLoad=Util.lit_d(valeur);
	    condenserLoad_value.setText(Util.aff_d(condenserLoad,3));
		double Tout=Util.lit_d(Util.extr_value(ligne_data, "Tout_value"));
	    Tout_value.setText(Util.aff_d(Tout,2));
		double Q=Util.lit_d(Util.extr_value(ligne_data, "Q_value"));
	    Q_value.setText(Util.aff_d(Q,2));
		double current=Util.lit_d(Util.extr_value(ligne_data, "Compr_value"));
	    Compr_value.setText(Util.aff_d(current,2));
	    valeur=Util.extr_value(ligne_data, "sigma_value");
        if(valeur!=null)sigma=Util.lit_d(valeur);
	    sigma_value.setText(Util.aff_d(sigma,3));
	}
	
    public String saveCompParameters(){
	    String h="";
	    h=h
	    +"sigma_value="+sigma_value.getText()+tab
	    +"condenserLoad_value="+condenserLoad_value.getText()+tab
	    +"Tout_value="+Tout_value.getText()+tab
	    +"Q_value="+Q_value.getText()+tab
	    +"Compr_value="+Compr_value.getText()+tab
	    ;
        return h;
    }
}